<script lang="ts">
	import { Dialog } from "attractions";
	import type { DialogProps } from "attractions/dialog/dialog.svelte";
	import { categories } from "@/lib/stores";
	import type { Transaction } from "@/utils/types";
    import { tick } from "svelte"

	export let transaction: Transaction | undefined;
	export let closeCallback: DialogProps["closeCallback"];
	// export let validation_results: { [key: string]: ValidationResult } | undefined;
	// export let form_action: string = "";

	let width = "500px";
	let form: HTMLFormElement;

	let selected_category: number;

	function category_click(id: number) {
		selected_category = id;
		tick().then(() => form.submit());
	}
</script>

<div class="wrapper">
	<Dialog {closeCallback} title="Válassz kategóriát">
		<div class="dialog-content">
			<form class="categories" method="post" bind:this={form} action="?/set_category">
				{#each $categories as { id, name, icon }}
					<div class="category" on:click={() => category_click(id)}>
						<img src={`data:image/jpeg;base64,${icon}`} alt={name} class="icon" />
						{name}
					</div>
				{/each}
				<input type="hidden" value={transaction?.id} name="transaction_id" />
				<input type="hidden" value={selected_category} name="category" />
			</form>
		</div>
	</Dialog>
</div>

<style>
	.wrapper {
		display: flex;
		align-items: center;
	}
	.dialog-content {
		display: flex;
		width: 300px;
		align-items: center;
		justify-content: center;
	}
	.categories {
		display: flex;
		flex-direction: column;
		row-gap: 12px;
		width: max-content;
	}
	.category {
		display: flex;
		align-items: center;
		cursor: pointer;
		transition: 0.3s scale;
	}
	.category:hover {
		scale: 1.1;
	}
	.icon {
		width: 30px;
		padding-right: 12px;
	}
</style>
